(** Trees pretty printing. *)

type column

val new_column : column

val append_left : column -> string -> column
val append_center : column -> string -> column
val append_cols : column -> column list -> column

val join : column list -> column

val printer : Format.formatter -> column -> unit
