(** Indexed structures using lists. *)

include List

(*Dfinition d'un type Liste*)

type 'a t = 'a list

(*Renommage (utile ou pas) de structures de liste*)

let empty = []
let single =fun v -> [v]

let concat = append
let equal = (=)

(*Fonction liste vide*)
let is_empty = function
  | [] -> true
  | _  -> false

(*Fonction find_first*)
(*3 arguments : f : fonction  ; size : entier, taille de la liste ; lst : liste*)
(*Fonction complique pour pas grand chose...*)

let find_first f size lst =
  let rec skip a lst =
    if a = 0 
		then search size lst 
		else match lst with
			| _::q -> skip (a-1) q
			| _  -> raise Not_found
  and search i = function
      | t::q -> if f t 
					then i 
					else search (i + 1) q
      | _    -> -1
  in skip size lst

(*Inutile*)
  
let replace f lst n =
  let rec aux acc pos = function
    | [] -> raise Not_found
    | t::q -> if pos = n
                then List.rev_append acc ((f t)::q)
                else aux (t::acc) (pos+1) q
  in aux [] 0 lst

let remove lst n =
  let rec aux acc pos = function
    | [] -> raise Not_found
    | t::q -> if pos = n
                then List.rev_append acc q
                else aux (t::acc) (pos + 1) q
  in aux [] 0 lst

let from_list (x: 'a list):'a t = x
let to_list   (x: 'a t):'a list = x
